Usage nutfilter
===============

The program `nutfilter` is intended to be used as a filter to `geng` and should be called for examples like this

    geng -cq 7  | ./nutfilter

Input is a list of `graph6` graphs. Output depends on command line options and is always
to the standard output channel. Some statistics are sent to the standard error channel

* `./nutfilter` or `./nutfilter -n` outputs only the nut graphs that occur in the input
* `./nutfilter -s` same, with slower algorithm (for timings)
* `./nutfilter -r` outputs the rank of each input graph, in the same order as the input
* `./nutfilter -p` outputs the 'pseudo'-rank of each input graph, in the same order as the input


Usage nutgen
============

The program `nutgen` is an extended version of `geng` which incorporates our algorithm to generate nut graphs and is much more efficient than using `nutfilter`.

The command line arguments for using `nutgen` are the same as for `geng`.

Examples:

* `./nutgen 10 -d2` outputs all nut graphs on 10 vertices.
* `./nutgen 14 -d2 -D3` outputs all chemical nut graphs on 14 vertices (a chemical nut graph has degree at most 3).
* `./nutgen 11 -d2 -t` outputs all nut graphs on 11 vertices with girth at least 4.
* `./nutgen 14 -d2 -tf` outputs all nut graphs on 14 vertices with girth at least 5.



Geng
----
The program `geng` can be obtained from [here](http://users.cecs.anu.edu.au/%7ebdm/nauty/).

Dependencies and installation
=============================
Nutgen uses the [GNU Multiprecision Arithmetic Library](https://gmplib.org/). This library can be installed on ubuntu with the following commaind

    sudo apt-get install libgmp3-dev

Nutgen uses a library `libpgeng.a` which must be stored in the `libs` directory and may be machine
dependent. This library must be built from the [nauty](http://users.cecs.anu.edu.au/%7ebdm/nauty/) distribution, as follows:

* Copy the files `pgeng.c`, `pgeng.h` and  `makefile-pgeng` from the `libs` directory
  to the nauty source directory.
* In that source directory, run `make -fmakefile-pgeng`
* This generates the file `libpgeng.a` in that source directory
* Copy this file to the `libs` directory of this project
* You may then run `make -fmakefile-pgeng veryclean` to clean up the generated files


The program `positionzero` which determines the position of the NBO uses the [GNU Scientific Library](https://www.gnu.org/software/gsl/). 

* Download, configure and make the latest version of gsl.
* `LD_LIBRARY_PATH` should point to the location where the gsl libraries are installed. In most cases this will be: `export LD_LIBRARY_PATH=/usr/local/lib`
* Make using `make positionzero`



