/* graph_config.h
 *
 * Copyright (c) 2016 Ghent University
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/**
 * Some parameters used by all files in this project
 */

#ifndef GRAPH_CONFIG_H
#define GRAPH_CONFIG_H

//#define MAXN 32    // upper limit for the number of vertices in the graphs considered
                   // preferably a (multiple of) a power of 2

//#define MAXN 128
#define MAXN 300

/**
 * Do not change anything below
 */

typedef unsigned int ADJ_LIST[MAXN][MAXN];    // list of neighbours
typedef unsigned int DEGREES[MAXN];        // list of degrees

typedef unsigned char ADJ_MATRIX[MAXN][MAXN]; // adjacency matrix
typedef unsigned int INT_ADJ_MATRIX[MAXN][MAXN]; // adjacency matrix, with entries stored as ints

typedef unsigned int (* ADJ_LIST_PTR)[MAXN];
typedef unsigned char (* ADJ_MATRIX_PTR)[MAXN];
typedef unsigned int (* INT_ADJ_MATRIX_PTR)[MAXN];


//For statistics:

unsigned long long int frequency_rank[MAXN+1];

#endif //GRAPH_CONFIG_H
