/* graphutils.h
 *
 * Copyright (c) 2016 Ghent University
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef GRAPHUTILS_H
#define GRAPHUTILS_H

#include <stdio.h>
#include "graph_config.h"

void print_graph(FILE *f, ADJ_LIST_PTR graph, unsigned int *degrees, int nv);

void print_adj_matrix(FILE *f, int nv, ADJ_MATRIX_PTR matrix);

void to_adj_matrix(ADJ_LIST_PTR graph, unsigned int *degrees, int nv, ADJ_MATRIX_PTR matrix);
void to_int_adj_matrix(ADJ_LIST_PTR graph, unsigned int *degrees, int nv, INT_ADJ_MATRIX_PTR matrix);

void bits_to_adj_matrix(unsigned int *graph, int nv, ADJ_MATRIX_PTR matrix);
void bits_to_adj_list(unsigned int *graph, int nv, ADJ_LIST_PTR adj_list, unsigned int *degrees);
void bits_to_int_adj_matrix(unsigned int *graph, int nv, INT_ADJ_MATRIX_PTR matrix);

#endif //GRAPHUTILS_H
