/* mp.h
 *
 * Copyright (c) 2016 Ghent University
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef NUTFILTER_MP_H
#define NUTFILTER_MP_H

#include <gmp.h>
#include "graph_config.h"

typedef mpz_t MP_MATRIX[MAXN][MAXN]; // multiprecision adjacency matrix
typedef mpz_t (* MP_MATRIX_PTR)[MAXN];

void to_mp_matrix(ADJ_LIST_PTR graph, unsigned int *degrees, int nv, MP_MATRIX_PTR matrix);

void bits_to_old_mp_matrix(unsigned int *graph, int nv, MP_MATRIX_PTR matrix);

void init_mp_matrix (MP_MATRIX_PTR matrix);

void clear_mp_matrix (int nv, MP_MATRIX_PTR matrix);

void print_mp_matrix (FILE *f, int nv, MP_MATRIX_PTR matrix);

int reduce_mp_matrix (int nv, MP_MATRIX_PTR matrix);

int check_zeroless_kernel_vector_mp_matrix (int nv, MP_MATRIX_PTR matrix);

int diagonalize_old_mp_matrix(int nv, MP_MATRIX_PTR matrix, MP_MATRIX_PTR result);

#endif //NUTFILTER_MP_H
