/* nuciferfilter.c
 * 
 * Copyright (c) 2016 Ghent University
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#include <stdio.h>
#include <getopt.h>
#include <stdlib.h>

#include "graph_config.h"
#include "main.h"
#include "graphutils.h"
#include "longmod.h"


//Returns 1 if the graph is a nucifer, else returns 0
int is_a_nucifer(ADJ_LIST_PTR graph, unsigned int *degrees, int nv) {
    //fprintf(stderr, "Org graph:\n");
    //print_graph(stderr, graph, degrees, nv);
    
    INT_ADJ_MATRIX int_matrix;
    to_int_adj_matrix(graph, degrees, nv, int_matrix);    
    
    return longmod_is_nucifer(nv, int_matrix);
}
    

int main(int argc, char **argv) {
    
    fprintf(stderr, "Warning: only correct up to 22 vertices!\n");
    
    main_filter_adj_list(&is_a_nucifer);
    
}

